varying vec2 LightmapCoords;
varying vec2 texcoord;
varying vec4 glcolor;
varying vec3 Normal;
attribute vec4 mc_Entity;
flat varying float material;
varying vec3 ViewPos;

void init_generic() {
    gl_Position = ftransform();
    texcoord = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    LightmapCoords = mat2(gl_TextureMatrix[1]) * gl_MultiTexCoord1.st;
    LightmapCoords = (LightmapCoords * 33.05f / 32.0f) - (1.05f / 32.0f);
    material = mc_Entity.x;
    ViewPos = (gl_ModelViewMatrix * gl_Vertex).xyz;
    Normal = gl_NormalMatrix * gl_Normal;
    glcolor = gl_Color;
}
