float random(vec2 coords) {
   return fract(sin(dot(coords.xy, vec2(12.9898,78.233))) * 43758.5453);
}

vec3 dither(vec3 Color, vec2 Pos) {
    const float NOISE_STR = 1./255;
    Color += mix(-NOISE_STR, NOISE_STR, random(Pos));
    return Color;
}

vec3 to_view_pos(vec3 p) {
	vec4 iProjDiag = vec4(gbufferProjectionInverse[0].x, gbufferProjectionInverse[1].y, gbufferProjectionInverse[2].zw);
  	vec3 p3 = p * 2. - 1.;
  	vec4 fragposition = iProjDiag * p3.xyzz + gbufferProjectionInverse[3];
  	return fragposition.xyz / fragposition.w;
}

vec3 to_player_pos(vec3 p) {
    return mat3(gbufferModelViewInverse) * p;
}